if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("MoneyMod Symbol","MoneyMod","$Pref::MoneyMod::CurrencySymbol","string 50 55","Server_MoneyMod", "$", 0, 0);
   RTB_registerPref("Starting Money","MoneyMod","$Pref::MoneyMod::StartingMoney","int 0 99999","Server_MoneyMod", 100, 0, 0);
   RTB_registerPref("addMoney Event Enabled", "MoneyMod", "$Pref::MoneyMod::addMoney", "bool", "Server_MoneyMod", 1, 0, 0);
   RTB_registerPref("deductMoney Event Enabled", "MoneyMod", "$Pref::MoneyMod::deductMoney", "bool", "Server_MoneyMod", 1, 0, 0);
   RTB_registerPref("setMoney Event Enabled", "MoneyMod", "$Pref::MoneyMod::setMoney", "bool", "Server_MoneyMod", 1, 0, 0);
}
else
{
   $Pref::MoneyMod::CurrencySymbol = "$";
   $Pref::MoneyMod::StartingMoney = 100;
   $Pref::MoneyMod::addMoney = 1;
   $Pref::MoneyMod::deductMoney = 1;
   $Pref::MoneyMod::setMoney = 1;
}

function serverCmdMoneyInfo(%client, %stuff)
{
	%client.player.curMoney = mFloatLength(%client.player.curMoney, 1);
	if(!%stuff)
		messageClient(%client,'',"\c3Money Stats\c6: <color:00FF00>"@$Pref::MoneyMod::CurrencySymbol @ %client.player.curMoney);
	else
		messageClient(%client,'',"\c3Money Stats\c6: <color:00FF00>"@$Pref::MoneyMod::CurrencySymbol @"0.0");
}

function serverCmdGrantMoney(%client, %target, %num)
{
	if(%client.isAdmin || %client.isSuperAdmin && (%num >= 0 || %num <= 0) && isObject(findClientByName(%target).player))
	{
		if(%num > 0)
		{
			%target = findClientByName(%target);
			%target.player.curMoney += %num;
			messageClient(%target,'',"\c3"@%client.getPlayerName()@"\c6 has given you <color:00FF00>"@$Pref::MoneyMod::CurrencySymbol @ %num@"\c6.");
			serverCmdMoneyInfo(%target);
		}
		else
		{
			messageClient(%client,'',"You cannot grant numbers less than zero.");
		}
	}
	else
	{
		messageClient(%client,'',"Error in using command.");
	}
}

function serverCmdTakeMoney(%client, %target, %num)
{
	if(%client.isAdmin || %client.isSuperAdmin && (%num >= 0 || %num <= 0) && isObject(findClientByName(%target).player) && isObject(%client.player))
	{
		if(%num > 0 && findClientByName(%target).player.curMoney >= %num)
		{
			%target = findClientByName(%target);
			%target.player.curMoney -= %num;
			%client.player.curMoney += %num;
			messageClient(%target,'',"\c3"@%client.getPlayerName()@"\c6 has taken <color:FF0000>"@$Pref::MoneyMod::CurrencySymbol @ %num@"\c6 from you.");
			serverCmdMoneyInfo(%client);
			serverCmdMoneyInfo(%target);
		}
		else
		{
			messageClient(%client,'',"Error concerning the amount of money taken.");
		}
	}
	else
	{
		messageClient(%client,'',"Error in using command.");
	}
}

function serverCmdDissolveMoney(%client, %target, %num)
{
	if(%client.isAdmin || %client.isSuperAdmin && (%num >= 0 || %num <= 0) && isObject(findClientByName(%target).player) && isObject(%client.player))
	{
		if(%num > 0 && findClientByName(%target).player.curMoney >= %num)
		{
			%target = findClientByName(%target);
			%target.player.curMoney -= %num;
			messageClient(%target,'',"\c3"@%client.getPlayerName()@"\c6 has dissolved <color:FF0000>"@$Pref::MoneyMod::CurrencySymbol @ %num@"\c6 of your money.");
			serverCmdMoneyInfo(%target);
		}
		else
		{
			messageClient(%client,'',"Error concerning the amount of money dissolved.");
		}
	}
	else
	{
		messageClient(%client,'',"Error in using command.");
	}
}

function serverCmdGiveMoney(%client, %target, %num)
{
	if(isObject(%client.player) && isObject(findClientByName(%target).player) && (%num >= 0 || %num <= 0))
	{
		if(%num > 0 && %client.player.curMoney >= %num)
		{
			%target = findClientByName(%target);
			%target.player.curMoney += %num;
			%client.player.curMoney -= %num;
			messageClient(%target,'',"\c3"@%client.getPlayerName()@"\c6 has given you <color:00FF00>"@$Pref::MoneyMod::CurrencySymbol @ %num@"\c6.");
			messageClient(%client,'',"\c6You have given \c3"@%target.getPlayerName()@" <color:FF0000>"@$Pref::MoneyMod::CurrencySymbol @ %num@"\c6.");
			serverCmdMoneyInfo(%client);
			serverCmdMoneyInfo(%target);
		}
		else
		{
			messageClient(%client,'',"Error concerning the amount of money given.");
		}
	}
	else
	{
		messageClient(%client,'',"Error in using command.");
	}
}

function fxDTSBrick::MM_addMoney(%brick, %amount, %client)
{
	if($Pref::MoneyMod::addMoney)
	{
		%player = %client.player;
		%player.curMoney += %amount;
		messageClient(%client,'',"<color:00FF00>"@$Pref::MoneyMod::CurrencySymbol @ %amount@"\c6 money has been added via events.");
		serverCmdMoneyInfo(%client);
	}
	else
	{
		messageClient(%client,'',"The server currently has the addMoney event disabled.");
	}
}

function fxDTSBrick::MM_deductMoney(%brick, %amount, %client)
{
	if($Pref::MoneyMod::deductMoney)
	{
		%player = %client.player;
		if(%player.curMoney >= %amount)
		{
			%player.curMoney -= %amount;
			messageClient(%client,'',"<color:FF0000>"@$Pref::MoneyMod::CurrencySymbol @ %amount@"\c6 of your money has been deducted via events.");
			serverCmdMoneyInfo(%client);
		}
		else if(%player.curMoney > 0)
		{
			messageClient(%client,'',"<color:FF0000>All\c6 of your money has been deducted via events.");
			%player.curMoney -= %player.curMoney;
			serverCmdMoneyInfo(%client);
		}
		else
		{
			return;
		}
	}
	else
	{
		messageClient(%client,'',"The server currently has the deductMoney event disabled.");
	}
}

function fxDTSBrick::MM_setMoney(%brick, %amount, %client)
{
	if($Pref::MoneyMod::setMoney)
	{
		%player = %client.player;
		%player.curMoney = %amount;
		messageClient(%client,'',"\c6Your money has been set to \c3"@$Pref::MoneyMod::CurrencySymbol @ %amount@"\c6 via events.");
		serverCmdMoneyInfo(%client);
	}
	else
	{
		messageClient(%client,'',"The server currently has the setMoney event disabled.");
	}
}

function fxDTSBrick::MM_checkMoney(%brick, %client)
{
	serverCmdMoneyInfo(%client);
}

function fxDTSBrick::MM_payFor(%brick, %amount, %client)
{
	%player = %client.player;
	if(%player.curMoney >= %amount)
	{
		%player.lastTransaction = 1;
		%player.curMoney -= %amount;
		serverCmdMoneyInfo(%player.client);
		messageClient(%client,'',"\c6Used brick for <color:FF0000>"@%amount@"\c6.");
	}
	else
	{
		messageClient(%client,'',"You haven't enough money. ("@%player.curMoney@"/"@%amount@")");
		%player.lastTransaction = 0;
	}
	%brick.MM_onPaySuccess(%player);
	%brick.MM_onPayFail(%player);
}

function fxDTSBrick::MM_onPaySuccess(%brick, %obj)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %obj;
	$InputTarget_["Client"] = %obj.client;
	if($Server::LAN)
   	{
      		$InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
   	}
   	else
   	{
      		if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
         		$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
      		else
         		$InputTarget_["MiniGame"] = 0;
   	}
	if(%obj.lastTransaction)
		%brick.processInputEvent("MM_onPaySuccess", %obj);
}

function fxDTSBrick::MM_onPayFail(%brick, %obj)
{
	$InputTarget_["Self"] = %brick;
	$InputTarget_["Player"] = %obj;
	$InputTarget_["Client"] = %obj.client;
	if($Server::LAN)
   	{
      		$InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
   	}
   	else
   	{
      		if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%client))
         		$InputTarget_["MiniGame"] = getMiniGameFromObject(%obj);
      		else
         		$InputTarget_["MiniGame"] = 0;
   	}
	if(!%obj.lastTransaction)
		%brick.processInputEvent("MM_onPayFail", %obj);
}



package joinmoney
{
	function gameConnection::onClientEnterGame(%client)
	{
		parent::onClientEnterGame(%client);
		if($Pref::MoneyMod::StartingMoney > 0)
			%client.player.curMoney += $Pref::MoneyMod::StartingMoney;
		serverCmdMoneyInfo(%client);
	}

	function gameConnection::onDeath(%client,%source,%killer,%type,%pos)
	{
		parent::onDeath(%client,%source,%killer,%type,%pos);
		serverCmdMoneyInfo(%client, 1);
	}
	function MinigameSO::displayScoresList(%this)
  	{
   		//We had to remove this to fix a bug, sorry!
	}

	function VCE_initServer()
	{
		parent::VCE_initServer();
		registerSpecialVar("Player", "curMoney", "mFloatLength(%this.curMoney, 1)");
	}
};
activatePackage(joinMoney);

registerOutputEvent("fxDTSBrick", "MM_payFor", "int 0 99999 0", 1);
registerOutputEvent("fxDTSBrick", "MM_addMoney", "int 0 99999 0", 1);
registerOutputEvent("fxDTSBrick", "MM_deductMoney", "int 0 99999 0", 1);
registerOutputEvent("fxDTSBrick", "MM_setMoney", "int 0 99999 0", 1);
registerOutputEvent("fxDTSBrick", "MM_checkMoney", "", 1);
registerInputEvent("fxDTSBrick", "MM_onPaySuccess", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "MM_onPayFail", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");